/* ===========================================================================
              LENGTH OF THE LONGEST COMMON SUBSEQUENCE
The program uses the module for lists in the file `list_module.cpp'
=========================================================================== */
#include <iostream.h>
typedef int Values;
#include "list_module.cpp"  // Now we have lists of int
const list nil=NULL;        // We use nil, instead of NULL.

int length(list L)
{if (L==nil) {return 0;} else {return 1+length(tail(L));}}

int max(int n, int m) {if (n>=m) {return n;} else {return m;}}

int lcs(list s1, list s2)
{if ((length(s1)==0) || (length(s2)==0)) {return 0;}
 else {if (head(s1)==head(s2)) {return 1+lcs(tail(s1),tail(s2));}
       else {return max(lcs(s1,tail(s2)), lcs(tail(s1),s2));};};}

void main()
{list list1=cons(1,cons(2,cons(3,cons(3,cons(3,
            cons(1,cons(3,cons(1,cons(1,nil)))))))));
list list2=cons(3,cons(2,cons(1,cons(3,cons(1,
           cons(1,cons(3,cons(2,cons(1,nil)))))))));
cout <<"\nlist1 = "; printlist(list1);
cout <<"\nlist2 = "; printlist(list2);
cout <<"\n\nlength of common longest subsequence = ";
cout << lcs(list1,list2) << "\n";
}
/* input: output:
------------------------------------------------------------------------------
          list1 = 1->2->3->3->3->1->3->1->1->nil
          list2 = 3->2->1->3->1->1->3->2->1->nil

          length of longest common subsequence =  5
------------------------------------------------------------------------------
Note. The longest common subsequence is: 2 3 1 3 1, or: 2 1 3 1 1,
or: 2 3 1 1 1
--------------------------------------------------------------------------- */
